/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2012 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: core_sil.h 2330 2012-03-19 07:04:33Z mit-kimai $
 */

/*
 *	sil.hΥƥ¸H8/300Hѡ
 */

#ifndef TOPPERS_CORE_SIL_H
#define TOPPERS_CORE_SIL_H

#ifndef TOPPERS_MACRO_ONLY
#include "h8300h_gcc/core_insn.h"
#include "h8300h_gcc/h8300h.h"


/*
 *  NMI٤Ƥγߤζػ
 *  ͡߶ػγߥޥθ͡ɽ
 */
Inline IIPM
TOPPERS_disint(void)
{
	IIPM	TOPPERS_iipm;

	TOPPERS_iipm = current_ccr();
    disint();
	TOPPERS_iipm &= H8CCR_INT_MASK_BIT;
	return(TOPPERS_iipm);
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
#define TOPPERS_set_iipm(TOPPERS_iipm)	set_ccr(TOPPERS_iipm)

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		IIPM TOPPERS_iipm
#define SIL_LOC_INT()	((void)(TOPPERS_iipm = TOPPERS_disint()))
#define SIL_UNL_INT()	(TOPPERS_set_iipm(TOPPERS_iipm))

/*
 *  Ԥ
 */
extern void sil_dly_nse(ulong_t dlytim);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_BIG				/* ӥåǥ */

/*****ʲȤΥ󥿡ե˴ޤޤʤʬ*********/

/**************************************************************
 *  黻 SILγĥ
 *    ¢ڥե롦쥸(SFR)黻륱
 *    ˤо줹뤿ᡢͽޥƤ
 *    
 *    λǤϡsil_reb_memƤʤᡢ
 *    ʥ饤ؿǤϤʤ˴ؿޥˤƤ롣
 **************************************************************/

/*
 *	8ӥåȡ쥸OR黻
 *   void sil_orb_reg(uint8_t *p_reg, uint8_t bitptn);
 */
#define sil_orb_reg(p_reg, bitptn)				\
do {											\
	uint8_t *p_mem = (p_reg);					\
	uint8_t reg_val = sil_reb_mem(p_mem);		\
												\
	reg_val |= (uint8_t)(bitptn);				\
	sil_wrb_mem(p_mem, reg_val);				\
} while(false)

/*
 *	8ӥåȡ쥸AND黻
 *   void sil_anb_reg(uint8_t *p_reg, uint8_t bitptn);
 */
#define sil_anb_reg(p_reg, bitptn)				\
do {											\
	uint8_t *p_mem = (p_reg);					\
	uint8_t reg_val = sil_reb_mem(p_mem);		\
												\
	reg_val &= (uint8_t)(bitptn);				\
	sil_wrb_mem(p_mem, reg_val);				\
} while(false)

/*
 *	16ӥåȡ쥸OR黻
 *   void sil_orh_reg(uint16_t *p_reg, uint16_t bitptn);
 */
#define sil_orh_reg(p_reg, bitptn)				\
do {											\
	uint16_t *p_mem = (p_reg);					\
	uint16_t reg_val = sil_reh_mem(p_mem);		\
												\
	reg_val |= (uint16_t)(bitptn);				\
	sil_wrh_mem(p_mem, reg_val);				\
} while(false)


/*
 *	16ӥåȡ쥸AND黻
 *   void sil_anh_reg(uint16_t *p_reg, uint16_t bitptn);
 */
#define sil_anh_reg(p_reg, bitptn)				\
do {											\
	uint16_t *p_mem = (p_reg);					\
	uint16_t reg_val = sil_reh_mem(p_mem);		\
												\
	reg_val &= (uint16_t)(bitptn);				\
	sil_wrh_mem(p_mem, reg_val);				\
} while(false)

/*
 *	32ӥåȡ쥸OR黻
 *   void sil_orw_reg(uint32_t *p_reg, uint32_t bitptn);
 */
#define sil_orw_reg(p_reg, bitptn)				\
do {											\
	uint32_t *p_mem = (p_reg);					\
	uint32_t reg_val = sil_rew_mem(p_mem);		\
												\
	reg_val |= (uint32_t)(bitptn);				\
	sil_wrw_mem(p_mem, reg_val);				\
} while(false)


/*
 *	32ӥåȡ쥸AND黻
 *   void sil_anw_reg(uint32_t *p_reg, uint32_t bitptn);
 */
#define sil_anw_reg(p_reg, bitptn)				\
do {											\
	uint32_t *p_mem = (p_reg);					\
	uint32_t reg_val = sil_rew_mem(p_mem);		\
												\
	reg_val &= (uint32_t)(bitptn);				\
	sil_wrw_mem(p_mem, reg_val);				\
} while(false)

#ifndef TOPPERS_MACRO_ONLY
/*
 *DDRֹ
 *
 *ΥǥåѤ롣
 *ʤݡ7ѤDDR쥸ʤᡢάƤ롣
 */
enum T_IO_PORT {
	IO_PORT1,
	IO_PORT2,
	IO_PORT3,
	IO_PORT4,
	IO_PORT5,
	IO_PORT6,
	IO_PORT8,
	IO_PORT9,
	IO_PORTA,
	IO_PORTB
};

typedef enum T_IO_PORT IO_PORT;

/*
 *I/OݡȤΥǡǥ쥯󡦥쥸DDRؤΥ
 *
 *H8DDRϽ񤭹ѤǤꡢΤޤޤǤϽ˾ΥӥåȤ
 *ѹ뤳ȤǤʤbset,bclr̿ǤԲġ
 *ΤᡢܼǤϡ˥ƥݥѰդơDDR
 *ͤݻˡΤäƤ롣
 */
extern uint8_t sil_reb_ddr(IO_PORT port) throw();
extern void sil_wrb_ddr(IO_PORT port, uint8_t data) throw();
extern void sil_anb_ddr(IO_PORT port, uint8_t data) throw();
extern void sil_orb_ddr(IO_PORT port, uint8_t data) throw();

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_SIL_H */
