/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2012 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: core_timer.h 2330 2012-03-19 07:04:33Z mit-kimai $
 */

/*
 *  ޥɥ饤СH8/300Hѡ
 *
 *  IMIA0
 */

#ifndef TOPPERS_CORE_TIMER_H
#define TOPPERS_CORE_TIMER_H

#include <sil.h>

/*
 *  쥸
 */
#define SYSTEM_TIMER_CNT_h	(SYSTEM_TIMER + H8TCNT_h)
#define SYSTEM_TIMER_TCR_b	(SYSTEM_TIMER + H8TCR_b)
#define SYSTEM_TIMER_TIOR_b	(SYSTEM_TIMER + H8TIOR_b)

#ifdef TOPPERS_H8_16TU

#define SYSTEM_TIMER_IER_b	H816TU_TISRA_b
#define SYSTEM_TIMER_IFR_b	H816TU_TISRA_b
#define SYSTEM_TIMER_TSTR_b	H816TU_TSTR_b

#else	/* TOPPERS_H8_16TU */
#ifdef TOPPERS_H8_ITU

#define SYSTEM_TIMER_IER_b	(SYSTEM_TIMER + H8TIER_b)
#define SYSTEM_TIMER_IFR_b	(SYSTEM_TIMER + H8TSR_b)
#define SYSTEM_TIMER_TSTR_b	H8ITU_TSTR_b

#else	/* TOPPERS_H8_ITU */

#error illegal timer type ! (use TOPPERS_H8_16TU or TOPPERS_H8_ITU)

#endif	/* TOPPERS_H8_ITU */
#endif	/* TOPPERS_H8_16TU */

#define SYSTEM_TIMER_GR_h	(SYSTEM_TIMER + H8GRA_h)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint16_t    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TO_CLOCK(nume, deno)    ((CLOCK)(TIMER_CLOCK * (nume) / (deno)))
#define TO_USEC(clock)          (((SYSUTM)(clock)) * 1000U / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK    ((CLOCK) 0xffffU)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	return((CLOCK)(sil_reh_mem((uint16_t *)SYSTEM_TIMER_CNT_h)));
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
	uint8_t ifr = sil_reb_mem((uint8_t *)SYSTEM_TIMER_IFR_b);
	ifr &= SYSTEM_TIMER_IF;
	return((bool_t)ifr);
}

/*
 *  ޳ߥϥɥ
 */
extern void target_timer_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_TIMER_H */
