/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2009 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: h8_3069f.c 2328 2012-03-16 06:14:19Z mit-kimai $
 */

/*
 *		ץå¸⥸塼H8/3069Fѡ
 */

#include "kernel_impl.h"

/*
 *  ֹintnoбIPR쥸ǤΥӥåֹ
 *
 *  ͭǤʤֹˤϡߡͤ뤳Ȥˤꡢ
 *  ֹ椬̵ͭȽ̤ˤѤƤ롣
 */
const uint8_t ipr_bit[TMAX_INTNO] = {
		DUMMY_IPR_BIT,				/*  0ꥻå  */
		
		DUMMY_IPR_BIT,				/*  1ꥶ  */
		DUMMY_IPR_BIT,				/*  2ꥶ  */
		DUMMY_IPR_BIT,				/*  3ꥶ  */
		DUMMY_IPR_BIT,				/*  4ꥶ  */
		DUMMY_IPR_BIT,				/*  5ꥶ  */
		DUMMY_IPR_BIT,				/*  6ꥶ  */

		NMI_IPR_BIT,				/*  7NMI  */

		DUMMY_IPR_BIT,				/*  8TRAPA #0  */
		DUMMY_IPR_BIT,				/*  9TRAPA #1  */
		DUMMY_IPR_BIT,				/* 10TRAPA #2  */
		DUMMY_IPR_BIT,				/* 11TRAPA #3  */

		7U,							/* 12IRQ0  */
		6U,							/* 13IRQ1  */
		5U,							/* 14IRQ2  */
		5U,							/* 15IRQ3  */
		4U,							/* 16IRQ4  */
		4U,							/* 17IRQ5  */

		DUMMY_IPR_BIT,				/* 18ꥶ  */
		DUMMY_IPR_BIT,				/* 19ꥶ  */

		3U,							/* 20:Watch Doc Timer */
		3U,							/* 21:Compare Match */

		DUMMY_IPR_BIT,				/* 22ꥶ  */
		DUMMY_IPR_BIT,				/* 23ꥶ  */

		2U,							/* 24:ITU0 IMIA0 */
		2U,							/* 25:ITU0 IMIB0 */
		2U,							/* 26:ITU0 OVI0  */

		DUMMY_IPR_BIT,				/* 27ꥶ  */

		1U,							/* 28:ITU1 IMIA1 */
		1U,							/* 29:ITU1 IMIB1 */
		1U,							/* 30:ITU1 OVI1  */
   
		DUMMY_IPR_BIT,				/* 31ꥶ  */

		0U,							/* 32:ITU2 IMIA2 */
		0U,							/* 33:ITU2 IMIB2 */
		0U,							/* 34:ITU2 OVI2  */
   
		DUMMY_IPR_BIT,				/* 35ꥶ  */

		7U,							/* 36:ITU3 CMIA0 */
		7U,							/* 37:ITU3 CMIB0 */
		7U,							/* 38:ITU3 CMIA1/CMIB1  */
		7U,							/* 39:TOVI0/TOVI1 */

		6U,							/* 40:ITU4 CMIA2 */
		6U,							/* 41:ITU4 CMIB2 */
		6U,							/* 42:ITU4 CMIA3/CMIB3  */
		6U,							/* 43:TOVI2/TOVI3 */

		5U,							/* 44:DMAC */
		5U,							/* 45:DMAC */
		5U,							/* 46:DMAC */
		5U,							/* 47:DMAC */
   
		DUMMY_IPR_BIT,				/* 48ꥶ  */
		DUMMY_IPR_BIT,				/* 49ꥶ  */
		DUMMY_IPR_BIT,				/* 50ꥶ  */
		DUMMY_IPR_BIT,				/* 51ꥶ  */

		3U,							/* 52:SCI0 ERI */
		3U,							/* 53:SCI0 RXI */
		3U,							/* 54:SCI0 TXI */
		3U,							/* 55:SCI0 TEI */
   
		2U,							/* 56:SCI1 ERI */
		2U,							/* 57:SCI1 RXI */
		2U,							/* 58:SCI1 TXI */
		2U,							/* 59:SCI1 TEI */
   
		1U,							/* 60:SCI2 ERI */
		1U,							/* 61:SCI2 RXI */
		1U,							/* 62:SCI2 TXI */
		1U							/* 63:SCI2 TEI */
};

