/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2007 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: h8_sci.h 2328 2012-03-16 06:14:19Z mit-kimai $
 */

/*
 *		H8 SCI ʰSIOɥ饤
 */

#ifndef TOPPERS_H8_SCI_H
#define TOPPERS_H8_SCI_H

#include "h8_sci_rename.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
	uint8_t		*p_base;	/* SCI Υ١ɥ쥹	*/
	uint32_t	baudrate;	/* ܡ졼		*/
	uint8_t		smr_init;	/* SMR 		*/
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block {
    const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;            /* ĥ */
    bool_t    openflag;         /* ץѤߥե饰 */
    bool_t    sendflag;         /* ߥ֥͡ե饰 */
    bool_t    getready;         /* ʸ */
    bool_t    putready;         /* ʸǤ */
} SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U			/* ǽХå */
#define SIO_RDY_RCV	2U			/* ΥХå */

/*
 *  SIOɥ饤Фν롼
 */
extern void h8_sci_initialize(intptr_t exinf);

/*
 * ͥ뵯ưΥСʽѤν
 */
extern void h8_sci_init(uint8_t portno);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void h8_sci_pol_putc(char c, ID siopid);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *h8_sci_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void h8_sci_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t h8_sci_snd_chr(SIOPCB *siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t h8_sci_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void  h8_sci_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void h8_sci_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void h8_sci_tx_isr(ID siopid);
extern void h8_sci_rx_isr(ID siopid);
#ifdef TOPPERS_H8_CFG_SCI_ERR_HANDLER
extern void h8_sci_err_isr(ID siopid);
#endif	/* of #ifdef TOPPERS_H8_CFG_SCI_ERR_HANDLER */

/*
 *  ꥢI/OݡȤǽХå
 */
extern void h8_sci_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void h8_sci_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_H8_SCI_H */
