/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 by GJ Designing Center
 *                     Printer Business Group RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2009-2010 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_config.h 2328 2012-03-16 06:14:19Z mit-kimai $
 */

/*
 *  åȰ¸⥸塼ʽŻ AKIH8-3069Fѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "akih8_3069f.h"

/*
 *  ץå¸⥸塼H8/300Hѡ
 */
#include "h8300h_gcc/h8_3069f/h8_3069f.h"
#include "h8300h_gcc/core_config.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  get_utm򥵥ݡȤ뤫ɤ
 */
#define SUPPORT_GET_UTM

/*
 *  ʰץ˥Υޥå
 *
 * 0x000000 - 0x07ffff  ¢ROMʰץ˥
 * 0x400000 - 0x43ffff  RAM.text.rodata
 * 0x440000 - 0x47ffff  RAM.data.bss
 * 0xfee000 - 0xfee0ff  I/O쥸(1)
 * 0xffbf20 - 0xffbfff  ¢RAMʰץ˥
 * 0xffc000 - 0xffc0ff  ¢RAM۳ߥ٥ΰ (.vectors)
 * 0xffc100 - 0xffff1f  ¢RAM󥿥ƥѥå
 * 0xffff20 - 0xffffe9  I/O쥸(2)
 */


/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 *RAMѤ롣
 */
#if defined(ROM)

/*  ROMʳRAMѡ  */
#define DEFAULT_ISTKSZ		H8IN_RAM_SIZE	/*  å  */
#define DEFAULT_ISTK		(void *)H8IN_RAM_BASE	/*  Ƭ  */

#elif defined(INMEM_ONLY)

/*  ROM¢Τ߻ѡ */
#define DEFAULT_ISTKSZ		0x400			/*  å  */
#define DEFAULT_ISTK		(void *)0xfffb20		/*  Ƭ  */

#else	/* of #if defined(ROM) */

/*  ʰץ˥ʥ桼ץϳRAM˥ɡ  */
#define DEFAULT_ISTKSZ		0x3e20			/*  å  */
#define DEFAULT_ISTK		(void *)0xffc100	/*  Ƭ  */

#endif	/* of #if defined(ROM) */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void	target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void	target_exit(void);

#endif /* TOPPERS_MACRO_ONLY */


/*
 *  sil_dly_nseѤ
 *  test_dlynse.cǻѤ롣
 *  target_test.h˵Ҥ٤¾Ȥ
 *  ΤᡢΥե˵ҤƤ롣
 */
#if defined(ROM)

/*  ROMʳRAMѡ  */
#define	SIL_DLY_TIM1	 2305
#define	SIL_DLY_TIM2	  518

#elif defined(INMEM_ONLY)

/*  ROM¢Τ߻ѡ */
#define	SIL_DLY_TIM1	 1644
#define	SIL_DLY_TIM2	  512

#else	/* of #if defined(ROM) */

/*  ʰץ˥ʥ桼ץϳRAM˥ɡ  */
#define	SIL_DLY_TIM1	 3789
#define	SIL_DLY_TIM2	 1078

#endif	/* of #if defined(ROM) */

/*
 *  I/Oݡ DDRν
 *      h8_sil.cDDR롼ǻѤ롣
 *      ݡȣѤΤᡢάƤ롣
 */
#define H8P1DDR0        0xffU	/*  ɥ쥹Х  */
#define H8P2DDR0        0xffU	/*  ɥ쥹Х  */
#define H8P3DDR0        0xffU	/*  ǡХ  */
#define H8P4DDR0        0U      /*  ǡХ  */
#define H8P5DDR0        0xffU	/*  ɥ쥹Х  */
#define H8P6DDR0        0U
#define H8P8DDR0        (H8P8DDR_CS0|H8P8DDR_CS1|H8P8DDR_CS2|H8P8DDR_CS3)     /*  P83CS1  */
#define H8P9DDR0        0U
#define H8PADDR0        0U
#define H8PBDDR0        0U


#endif /* TOPPERS_TARGET_CONFIG_H */
