/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2010 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: target_support.S 2328 2012-03-16 06:14:19Z mit-kimai $
 */

/*
 *		åȰ¸⥸塼 ֥AKI-H8/3069Fѡ
 */

#define	TOPPERS_MACRO_ONLY
#define UINT32_C(val)		(val)		/* uint32_tޥ */
#include "kernel_impl.h"
#include "target_config.h"

/*
 *  ٥ΥåȰ¸ν
 *
 *  ȥåץ⥸塼ǡν˸ƤӽФ롥
 */
	.h8300h
	.text
	.align 2

	.globl	_hardware_init_hook
_hardware_init_hook:
	/*
	 *  ꡼ǤϡDRAMͭˤ롣
	 *ʳDRAMѤ
	 */
#ifdef ROM
	mov.b	#0xff, r1l
	mov.l	#H8P1DDR_b, er0
	mov.b	r1l, @er0	/* enable A0  - A7  */

	add.b	#(H8P2DDR_b - H8P1DDR_b), r0l
	mov.b	r1l, @er0	/* enable A8  - A15 */

	add.b	#(H8P3DDR_b - H8P2DDR_b), r0l
	mov.b	r1l, @er0	/* enable D8  - D15 */

	mov.b	#H8P5DDR_A16, r0h
	mov.b	r0h, @H8P5DDR_b	/*  Enable A16		*/
#endif	/*  #ifdef ROM  */

	/*
	 *  EthernetǥХѤ硢CS1ꤷʤ
	 *ǥХư롣
	 */
#if defined(ROM) || defined(INMEM_ONLY)
	mov.b	#H8P8DDR0, r0h
	mov.b	r0h, @H8P8DDR_b	/*  Enable CS1/CS2	*/
#endif /* defined(ROM) || defined(INMEM_ONLY) */


#ifdef ROM
	mov.b	#H8PBDDR_UCAS, r0h
	mov.b	r0h, @H8PBDDR_b	/*  Enable UCAS		*/

		/*  DRAM: 2,048/32ms: 32ms / 2,048 = 15.625us	*/
		/*  20MHz / 8 / 39 = 1 / 15.6us			*/
	mov.b	#((32*(CPU_CLOCK/1000))/(8*2048)), r0h
	mov.b	r0h, @H8RTCOR_b

	mov.b	#H8RTMCSR_CKS1, r0h
	mov.b	r0h, @H8RTMCSR_b /*  clock / 8			*/

	mov.b	#(H8DRCRB_RCYCE | H8DRCRB_MXC1), r0h
	mov.b	r0h, @H8DRCRB_b	/*  column address: 10 bit, A23 - A10	*/

	/*
	 *åȤˤѤƤ볰RAMۤʤ
	 *Ω HM5117800
	 *OKI  M5117805D
	 *
	 *ξбˤ뤿ᡢ
	 *BE ӥåȡᣱ
	 *RDMӥåȡᣰ
	 *
	 *ܺ٤(toppers-users 1375)򻲾
	 *
	 */
	mov.b	#(H8DRCRA_BE | H8DRCRA_DRAS0), r0h
	mov.b	r0h, @H8DRCRA_b

	mov.l	#(CPU_CLOCK / 1000), er0    /*  Wait for DRAM stable	*/
_hw_init_hock_1:
	dec.l	#1, er0
	bne	_hw_init_hock_1

#endif	/*  #ifdef ROM  */

	/*
	 *  ХΥ
	 *  Хȡȥ롦쥸
	 *
	 *  CS1(RTL8019AS):	2WAIT
	 *  CS2(DRAM):		NOWAIT
	 *  CS3(DRAM):	NOWAIT
	 *  OTHER		3WAIT
	 */
	mov.b	#0xff, r0h
	mov.b	r0h, @H8WCRH_b

	mov.b	#(H8WCRL_W3_NOWAIT | H8WCRL_W2_NOWAIT | H8WCRL_W1_2WAIT | H8WCRL_W0_3WAIT), r0h
	mov.b	r0h, @H8WCRL_b

	/*
	 * ХΥơȤ
	 * Хơȡȥ롦쥸
	 */
	mov.b	#~(H8ASTCR_AST3 | H8ASTCR_AST2):8, r0h
	mov.b	r0h, @H8ASTCR_b
	rts

